export interface AddCategory {
    name: string;
    about: string;
    parent: number;
}
export interface EditCategory {
    category: number;
    name: string;
    about: string;
}
export interface RemoveCategory {
    category: number;
}
export interface AddTopic {
    title: string;
    content: string;
    author: string;
    category: number;
    parent: number;
}
export interface EditTopic {
    topic: number;
    title: string;
    content: string;
}
export interface RemoveTopic {
    topic: number;
}
export interface PinTopic {
    topic: number;
}
export interface UnpinTopic {
    topic: number;
}
export interface Vote {
    voter: string;
    topic: number;
    choice: number;
}
export interface Unvote {
    voter: string;
    topic: number;
}
export declare const addCategoryTypes: {
    AddCategory: {
        name: string;
        type: string;
    }[];
};
export declare const editCategoryTypes: {
    EditCategory: {
        name: string;
        type: string;
    }[];
};
export declare const removeCategoryTypes: {
    RemoveCategory: {
        name: string;
        type: string;
    }[];
};
export declare const addTopicTypes: {
    AddTopic: {
        name: string;
        type: string;
    }[];
};
export declare const editTopicTypes: {
    EditTopic: {
        name: string;
        type: string;
    }[];
};
export declare const removeTopicTypes: {
    RemoveTopic: {
        name: string;
        type: string;
    }[];
};
export declare const pinTopicTypes: {
    PinTopic: {
        name: string;
        type: string;
    }[];
};
export declare const unpinTopicTypes: {
    UnpinTopic: {
        name: string;
        type: string;
    }[];
};
export declare const voteTypes: {
    Vote: {
        name: string;
        type: string;
    }[];
};
export declare const unvoteTypes: {
    Unvote: {
        name: string;
        type: string;
    }[];
};
