"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Profiles = void 0;
const pineapple_1 = require("@snapshot-labs/pineapple");
const constants_1 = require("../../constants");
const agent_1 = require("../agent");
const types_1 = require("./types");
class Profiles extends agent_1.Agent {
    async setProfile({ user, name, about, twitter, discord, telegram, github }) {
        const { cid } = await (0, pineapple_1.pin)({ name, about, twitter, discord, telegram, github });
        const metadataURI = `ipfs://${cid}`;
        const sig = await this.client.sign(constants_1.DOMAIN, types_1.setProfileTypes, {
            user,
            metadata_uri: metadataURI
        });
        const args = [user, metadataURI, sig];
        return await this.client.invoke('profiles', 'set_profile', args);
    }
    async setStatement({ user, org, statement, status }) {
        const { cid } = await (0, pineapple_1.pin)({ statement, status });
        const metadataURI = `ipfs://${cid}`;
        const sig = await this.client.sign(constants_1.DOMAIN, types_1.setStatementTypes, {
            user,
            org,
            metadata_uri: metadataURI
        });
        const args = [user, org, metadataURI, sig];
        return await this.client.invoke('profiles', 'set_statement', args);
    }
}
exports.Profiles = Profiles;
